-- 每日消费
Lua_DailyConsumptionWindow = class("Lua_DailyConsumptionWindow", Lua_Window);
function Lua_DailyConsumptionWindow:ctor(p)
	self:superCall("ctor", p);

	self.windowName = "Lua_DailyConsumptionWindow";
	self.skinName = "DailyConsumptionWindow_skin";
end

function Lua_DailyConsumptionWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.roleIcon:setUrl("/images/common/ui_meirixiaofei.png");
	self.roleIcon:SetDimensions(500, 1000);
	self.roleIcon:setLocation(-470, 17, 0);

	self.selectedRewardsId = 1;

	self.btnList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 622, 72));
	self.btnList:setListCell(Lua_DailyConsumptionBtnItem, 72, 183, 999);
	self.btnList:setLocation(-58, 103, 0);

	self.rewardList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 372, 180));
	self.rewardList:setListCell(Lua_DailyConsumptionRewardItem, 90, 124, 3);
	self.rewardList:setLocation(-25, -29.5, 0);

	self.rechargeList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 343, 392));
	self.rechargeList:setListCell(Lua_DailyConsumptionRechargeItem, 138, 343, 1);
	self.rechargeList:setLocation(444.5, -15, 0);

	self.chargeBtn:addClickFuntion(self, self.onChargeClick);

	-- self:addLuaEvent("GET_REWARD_ITEM_INFORMATION", self, self.getData);
	self:addLuaEvent("UPDATE_ONEPANEL_DATA", self, self.setData);
	self:addLuaEvent("CHARGE_TYPE_CLICK", self, self.setSelected);

	local avo = DataCenter.OperationalActivitiesData:getActivitiesByType(Lua_OperationalActivitiesData.CONSUMPTION_DAY, nil);
	if avo ~= nil then
		DataCenter.OperationalActivitiesData:sGetOperationalActivities(avo.act_index,Lua_OperationalActivitiesData.CONSUMPTION_DAY);
	end

	local avo2 = DataCenter.OperationalActivitiesData:getActivitiesByType(Lua_OperationalActivitiesData.CONSUMPTION_TOTAL, nil);
	if avo2 ~= nil then
		DataCenter.OperationalActivitiesData:sGetOperationalActivities(avo2.act_index,Lua_OperationalActivitiesData.CONSUMPTION_TOTAL);
	end
end

function Lua_DailyConsumptionWindow:setData()
	local tempData = DataCenter.OperationalActivitiesData.act_detail;
	if tempData.first_type == Lua_OperationalActivitiesData.CONSUMPTION_DAY then
		self.dayData = tempData;
		self:setDayData();
	elseif tempData.first_type == Lua_OperationalActivitiesData.CONSUMPTION_TOTAL then
		self.totalData = tempData;
		self:setTotalData();
	end
end

function Lua_DailyConsumptionWindow:setSelected(val)
	self.chargeBtn:setBtnEnable(val.state == 0 or val.state == 2);
	self.redDot:setEnable(val.state == 0);

	if val.state == 1 then
		self.chargeBtn.label = LanUtil.getValue(127603);
	elseif val.state == 0 then
		self.chargeBtn.label = LanUtil.getValue(127602);
	elseif val.state == 2 then
		self.chargeBtn.label = LanUtil.getValue(127601);
	end
	self.isFlag = val.state;
	self.selectedRewardsId = val.index;

	self:showRewards()
end

function Lua_DailyConsumptionWindow:setDayData()
	if self.dayData ~= nil then
		self.dataList = Array();

		local idx = 0;
		for i = 1, #self.dayData.reward_info do
			if self.dayData.reward_info[i].draw_flag == 0 and idx == 0 then
				idx = i;
			end
			self.dataList:add({index = i, state = self.dayData.reward_info[i].draw_flag,
			need_gold = tonumber(self.dayData.reward_info[i].cond[2]), reward_set = self.dayData.reward_info[i].reward_set});
		end

		if self.dataList:getSize() > 0 then
			idx = idx == 0 and 1 or idx;
			self.btnList:setLuaArrayData(self.dataList, false);
			self.btnList:moveToIndex(idx, true);
			self.btnList:setSelected(idx);
			self:setSelected(self.dataList[idx]);
		end

		self.curChargeTxt.text = LanUtil.formateStr(LanUtil.getValue(127604), tostring(self.dayData.sub_value))
		self.tempTime = self.dayData.stop_tick - self.dayData.times;
		Lua_CommonUtil.removeTimer(self, self.countDown);
		Lua_CommonUtil.addTimer("countDown", 1, self, self.countDown);
		-- self:countDown();
	end
end

function Lua_DailyConsumptionWindow:countDown()
	self.tempTime = self.tempTime - 1;
	local str;
	if self.tempTime < 86400 then
		str = TimeTransform.getInstance():transSeconds9(math.floor(self.tempTime));
	else
		str = TimeTransform.getInstance():transSeconds1(math.floor(self.tempTime), false);
	end

	self.timeLabel.text = LanUtil.getValue(127605)..str;
	if self.tempTime <= 0 then
		self.timeLabel.text = LanUtil.getValue(122586);
		Lua_CommonUtil.removeTimer(self, self.countDown);
		Lua_WindowUtil.openWin("Lua_DailyConsumptionWindow", WinParam.ACTION_CLOSE, nil);
	end
end

function Lua_DailyConsumptionWindow:setTotalData()
	if self.totalData ~= nil then
		local totalList = Array();
		for i = 1, #self.totalData.reward_info do
			totalList:add({act_index = self.totalData.act_index, sum = self.totalData.second_sub,
				rewrd_info = self.totalData.reward_info[i]});
		end
		self.rechargeList:setLuaArrayData(totalList, false);
	end
end

function Lua_DailyConsumptionWindow:showRewards()
	if self.showRewardsId == self.selectedRewardsId then
		return;
	end

	local info;
	local tvo;
	local rsList = Array();
	for i = 1, #self.dataList[self.selectedRewardsId].reward_set do
		info = self.dataList[self.selectedRewardsId].reward_set[i];
		tvo = Lua_ToolVo.createToolVo(info.id, info.amount, info.bind);
		tvo:fromServer(info);
		tvo.bShowItemBg = true;
		tvo.amount = info.amount;
		rsList:add(tvo);
	end

	local spec_effect_item = self.dayData.reward_info[self.selectedRewardsId].spec_effect_item;
	local reward_set = self.dayData.reward_info[self.selectedRewardsId].reward_set;
	for i = 1, #spec_effect_item do
		for j = 1, #reward_set do
			if tonumber(reward_set[j].id) == tonumber(spec_effect_item[i]) then
				rsList[j].roundEffect = true;
			end
		end
	end
	self.rewardList:setLuaArrayData(rsList, false);
	self.showRewardsId = self.selectedRewardsId;
end

function Lua_DailyConsumptionWindow:onChargeClick(go)
	if self.isFlag == 0 then
		local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
		local leftNum = bagData:getLeftSize()
		if leftNum <= 0 then
			DataCenter.packData:showFullBagTip(Lua_PackData.BAG_PACK)
			return;
		end
		DataCenter.OperationalActivitiesData:buyReward(tonumber(self.dayData.act_index), tonumber(self.dayData.reward_info[self.selectedRewardsId].index), 1);
	elseif self.isFlag == 2 then
		Lua_WindowUtil.openWin("Lua_ShopWindow");
		Lua_WindowUtil.openWin("Lua_DailyConsumptionWindow", WinParam.ACTION_CLOSE, nil)
	end
end

function Lua_DailyConsumptionWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.rechargeList ~= nil then
		self.rechargeList:dispose();
		self.rechargeList = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.countDown);

	self:superCall("dispose");
end





--------------------------------------------------





Lua_DailyConsumptionBtnItem = class("Lua_DailyConsumptionBtnItem", Lua_ListCell)
function Lua_DailyConsumptionBtnItem:ctor(p)
	self:superCall("ctor", p, "DailyConsumptionRewardItem_skin");
end

function Lua_DailyConsumptionBtnItem:buildShowItem()
	self:superCall("buildShowItem");

	self.redDot:setEnable(false);
end

function Lua_DailyConsumptionBtnItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end
	self.numberTxt.text = LanUtil.formateStr(LanUtil.getValue(127600), tostring(data.need_gold)).."[-]";
	self.redDot:setEnable(data.state == 0);
end

function Lua_DailyConsumptionBtnItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);
	
	self.numberTxt.colorStr = Lua_ColorDefine.transColor(val and "DDF0F9" or "CAE6FE");
	self.selectSp:setEnable(val);
end

function Lua_DailyConsumptionBtnItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("CHARGE_TYPE_CLICK", self._data);
end





--------------------------------------------------





Lua_DailyConsumptionRewardItem = class("Lua_DailyConsumptionRewardItem", Lua_ListCell);
function Lua_DailyConsumptionRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_DailyConsumptionRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImage = Lua_ToolImage.new(self.content);
	self.itemImage:setDepth(3);
	self.itemImage:setCanClick(false);
end

function Lua_DailyConsumptionRewardItem:setData(data)
	self._data = data;

	if data ~= nil then
		local reward = Lua_ToolVo.new(data.id);
		reward.bShowItemBg = true;
		self.itemImage.data = data;
	else
		self.itemImage.data = nil;
		self.itemImage:showItemLvl(nil);
		self.itemImage:showRoundEff(false);
	end

	if self.itemImage.roundEff ~= nil then
		self.itemImage.roundEff:setSacle(0.9, 0.9, 0.9);
	end
end

function Lua_DailyConsumptionRewardItem:checkOutBound(showRect)
	if self._data.roundEffect ~= nil then
		local rect = Lua_Rectangle.new(self.itemX - 62, self.itemY - 45, 70, 70);
		self.itemImage:showRoundEff(showRect:containeRect(rect));
	end
end

function Lua_DailyConsumptionRewardItem:onPlayerSoundClick(go)
	if self._data ~= nil then
		Lua_PackUtil.showItemInfo(self._data, false, nil, true);
	end
end

function Lua_DailyConsumptionRewardItem:dispose()
	if self.itemImage ~= nil then
		self.itemImage:dispose();
		self.itemImage = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_DailyConsumptionRechargeItem = class("Lua_DailyConsumptionRechargeItem", Lua_ListCell)
function Lua_DailyConsumptionRechargeItem:ctor(p)
	self:superCall("ctor", p, "GetDailyTotalRewardItem_skin");
end

function Lua_DailyConsumptionRechargeItem:buildShowItem()
	self:superCall("buildShowItem");

	self.effectList = Array();

	self.redDot:setEnable(false);

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setDepth(3);
	self.rItem:setMaxShow(2);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	self.rItem:setItemScale(0.9, 0.9);
	self.rItem:setLocation(-119, -17);

	self.getBtn:addClickFuntion(self, self.onGetClick);
end

function Lua_DailyConsumptionRechargeItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	if tonumber(data.sum) >= tonumber(data.rewrd_info.cond[5]) then
		self.chargeTxt.text = LanUtil.formateStr(LanUtil.getValue(127606), data.rewrd_info.cond[5], data.sum, data.rewrd_info.cond[5], data.rewrd_info.cond[2]);
	else
		self.chargeTxt.text = LanUtil.formateStr(LanUtil.getValue(127607), data.rewrd_info.cond[5], data.sum, data.rewrd_info.cond[5], data.rewrd_info.cond[2]);
	end

	if data.rewrd_info.draw_flag == 0 then
		self.getBtn.label = LanUtil.getValue(122516);
		self.getBtn:setBtnEnable(true);
		self.redDot:setEnable(true);
	elseif data.rewrd_info.draw_flag == 1 then
		self.getBtn.label = LanUtil.getValue(121912);
		self.getBtn:setBtnEnable(false);
		self.redDot:setEnable(false);
	elseif data.rewrd_info.draw_flag == 2 then
		self.getBtn.label = LanUtil.getValue(122516);
		self.getBtn:setBtnEnable(false);
		self.redDot:setEnable(false);
	end

	local info;
	local tvo;
	local rsList = Array();
	for i = 1, #data.rewrd_info.reward_set do
		info = data.rewrd_info.reward_set[i];
		tvo = Lua_ToolVo.createToolVo(info.id, info.amount, info.bind);
		tvo.bShowItemBg = true;
		tvo:fromServer(info);
		rsList:add(tvo);
	end
	self.rItem:setRewardByArray(rsList);

	for i = 1, #data.rewrd_info.spec_effect_item do
		for j = 1, #data.rewrd_info.reward_set do
			if tonumber(data.rewrd_info.reward_set[j].id) == tonumber(data.rewrd_info.spec_effect_item[i]) then
				local reward = self.rItem:getToolImageById(data.rewrd_info.reward_set[j].id);
				reward:showRoundEff(true);
				self.effectList:add(reward);
			end
		end
	end
end

function Lua_DailyConsumptionRechargeItem:checkOutBound(showRect)
	local rect = Lua_Rectangle.new(self.itemX, self.itemY -50, 100, 55);
	for i = 1, self.effectList:getSize() do
		self.effectList[i]:showRoundEff(showRect:containeRect(rect));
	end
end

function Lua_DailyConsumptionRechargeItem:onGetClick(go)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	if bagData:getLeftSize() <= 0 then
		DataCenter.packData:showFullBagTip(Lua_PackData.BAG_PACK)
		return;
	end
	DataCenter.OperationalActivitiesData:buyReward(tonumber(self._data.act_index), tonumber(self._data.rewrd_info.index), 1);
end

function Lua_DailyConsumptionRechargeItem:dispose()
	if self.effectList ~= nil then
		self.effectList:dispose();
		self.effectList:clear();
		self.effectList = nil;
	end
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end